# Hacking `symantic-parser`

## Typing
```bash
make repl
make parsers/repl
make tests/repl
make benchmarks/repl
```

```bash
make ghcid
make parsers/ghcid
make tests/ghcid
make benchmarks/ghcid
```

## Testing
```bash
make tests
```

### Profiling
```bash
make tests/prof
make tests/prof t=.Golden.Parsers.G13
```

## Benchmarking

```bash
make benchmarks b=Brainfuck/ByteString/hanoi/'*' BENCHMARK_OPTIONS=-n1
```

## Profiling

#### Time
```bash
make benchmarks/prof-time b=Brainfuck/ByteString/hanoi/'*' BENCHMARK_OPTIONS=-n1
```
Then open `symantic-parser-benchmarks.eventlog.json` with [`speedscope`](https://www.speedscope.app).

#### Heap
```bash
make benchmarks/prof-heap b=Brainfuck/ByteString/hanoi/'*' BENCHMARK_OPTIONS=-n1
```
Then open `symantic-parser-benchmakrs.eventlog.html`.
